#import "@preview/tablex:0.0.9": gridx, hlinex, colspanx

#set page(
  margin: (y: 1.6cm, x: 3cm),
  header: align(right)[Company Name; October 2024]
)
#set text(
  font: "DejaVu Sans",
  size: 9pt,
  hyphenate: false,
)

#set par(
  leading: 4pt, /* Line spacing. */
  justify: false,
  first-line-indent: 0pt,
)

#set block(spacing: 7pt)
#show heading: set block(spacing: 6pt)

/* Header */
#grid(
  columns: (1fr, 1fr),
  align(left)[
  ],
  align(right)[
  ],
)

#align(
  center,
  gridx(
    columns: 1,
    inset: 0pt,
    align: center,
    text(size: 18pt)[*Christopher Lang*],
    [ #v(7pt) ],
    [ #text(size: 12pt)[University of Cambridge] ],
  )
)

#align(
  center,
  gridx(
    columns: 2,
    inset: 0pt,
    [ Address #h(24pt)],
    [ myemail\@cam.ac.uk ],
  )
)

#line(length: 100%)
= Education
#line(length: 100%)

*University of Cambridge*:
Undergraduate Computer Science (G400) Course. \
Expected graduation year 2026.
First-year result: *First Class* ranked *13th out of 121*. \

*A-Levels*:
The Billericay School.
Computer Science result ranked *top 50 in the country*. \
Computer Science *A\**, Further Mathematics *A\**, Mathematics *A\**, 2 EPQ's A\*, A.

*GCSE*: The Billericay School. Results include seven grade 9's.


= Work Experience
#line(length: 100%)

*Arm Internship* Summer 2024; 12 weeks:
- Working with C++ register-transfer level memory interconnect model.
- Applied data-oriented principles to OOP codebase for over 30% performance increase.
- Invented and built system for analysing model behaviour. Immediately adopted by team.
- Communicated progress and discussed feedback from team in weekly meetings.
- Reference available on request.

= Relevant Projects
#line(length: 100%)

*Linux/Communication* (EPQ grade A\*):
Authored a guide to coss-compiling from source, a Linux-based Operating System
for an embedded Arm device.

*Hardware/Computer Architecture*:
Designed a computer based on the 6502 microprocessor and constructed it using
PCBs and breadboards.

*C/Network Protocols*:
Implemented from scratch PDF libraries, SMTP clients and IMAP clients in C as case studies in
investigating what makes a good software interface.

*Computer Architecture/C*: Wrote camera module driver for a microcontroller and
ported an apriltag recognition library to build an autonomous drone.

*Hardware*: Built a development board for an ESP32 SOC.

*Linux/Shell/C*:
Wrote a shell script that extracts a table of x86_64 syscall types from the
Linux kernel source.

*Linux/Networking/git*: Hosts a git server in local network. Can be accessed
externally by ssh proxy-jumping through a cloud server.

*Linux/Operating Systems*:
Recently ported my personal website from NGINX running on a Debian AWS
Lightsail instance to httpd on an OpenBSD Vultr instance.

*Assembly/Linux*: Wrote video games for Linux and MS-DOS in x86_64 and x86 Assembly.

*GPU/Vulkan/C*:
Wrote several experimental 3D renderers in C/C++ and Vulkan, with a focus on
versatile code which can accommodate regular changes.

*Data Structures/Algorithms/Rust* (EPQ grade A): Wrote a chess engine in Rust as
part of an examined project.

*Cyber Security*: Passed the SANS foundations course with 96% in the final exam.
One of only 500 students to progress to the final 'Elite' stage of GCHQ's Cyber
Discovery Course. Applied my skills to help secure local business website

*Mathematics/Data Science/C/C++*: Built molecular dynamics software capable
of efficiently simulating water at the atomic scale.

*Food Bank/Mobile Applications*:
Built a full-stack, cross-platform mobile app for a local food bank using
Flutter and PHP, allowing staff to update the list of products in low stock.
Actively used by over 300 devices over the past 4 years.

= Extra Curricular
#line(length: 100%)

*Boxing*:
Trains at the Cambridge University Amateur Boxing Club six times a week.

*Philosophy*:
Interested in understanding abstraction from a philosophic perspective.
I believe that from the development of a formal model of abstraction,
a nomenclature will emerge capable of communicating what makes a good
software interface.
